/*
 * #%L
 * OME-XML Java library for working with OME-XML metadata structures.
 * %%
 * Copyright (C) 2006 - 2016 Open Microscopy Environment:
 *   - Massachusetts Institute of Technology
 *   - National Institutes of Health
 *   - University of Dundee
 *   - Board of Regents of the University of Wisconsin-Madison
 *   - Glencoe Software, Inc.
 * %%
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of any organization.
 * #L%
 */

/*-----------------------------------------------------------------------------
 *
 * THIS IS AUTOMATICALLY GENERATED CODE.  DO NOT MODIFY.
 *
 *-----------------------------------------------------------------------------
 */

package ome.xml.model;

import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import ome.xml.model.enums.*;
import ome.xml.model.enums.handlers.*;
import ome.xml.model.primitives.*;
import ome.units.quantity.*;
import ome.units.unit.Unit;

public class BinaryOnly extends AbstractOMEModelObject
{
  // Base:  -- Name: BinaryOnly -- Type: BinaryOnly -- modelBaseType: AbstractOMEModelObject -- langBaseType: Object

  // -- Constants --

  public static final String NAMESPACE = "http://www.openmicroscopy.org/Schemas/OME/2016-06";

  /** Logger for this class. */
  private static final Logger LOGGER =
    LoggerFactory.getLogger(BinaryOnly.class);

  // -- Instance variables --

  // MetadataFile property
  private String metadataFile;

  // UUID property
  private String uuid;

  // -- Constructors --

  /** Default constructor. */
  public BinaryOnly()
  {
  }



  /**
   * Constructs BinaryOnly recursively from an XML DOM tree.
   * @param element Root of the XML DOM tree to construct a model object
   * graph from.
   * @param model Handler for the OME model which keeps track of instances
   * and references seen during object population.
   * @throws EnumerationException If there is an error instantiating an
   * enumeration during model object creation.
   */
  public BinaryOnly(Element element, OMEModel model)
    throws EnumerationException
  {
    update(element, model);
  }

  /** Copy constructor. */
  public BinaryOnly(BinaryOnly orig)
  {
    metadataFile = orig.metadataFile;
    uuid = orig.uuid;
  }

  // -- Custom content from BinaryOnly specific template --


  // -- OMEModelObject API methods --

  /**
   * Updates BinaryOnly recursively from an XML DOM tree. <b>NOTE:</b> No
   * properties are removed, only added or updated.
   * @param element Root of the XML DOM tree to construct a model object
   * graph from.
   * @param model Handler for the OME model which keeps track of instances
   * and references seen during object population.
   * @throws EnumerationException If there is an error instantiating an
   * enumeration during model object creation.
   */
  public void update(Element element, OMEModel model)
    throws EnumerationException
  {
    super.update(element, model);
    if (element.hasAttribute("MetadataFile"))
    {
      // Attribute property MetadataFile
      setMetadataFile(String.valueOf(
        element.getAttribute("MetadataFile")));
    }
    if (element.hasAttribute("UUID"))
    {
      // Attribute property UUID
      setUUID(String.valueOf(
        element.getAttribute("UUID")));
    }
  }

  // -- BinaryOnly API methods --

  public boolean link(Reference reference, OMEModelObject o)
  {
    return super.link(reference, o);
  }

  // Property MetadataFile
  public String getMetadataFile()
  {
    return metadataFile;
  }

  public void setMetadataFile(String metadataFile)
  {
    this.metadataFile = metadataFile;
  }

  // Property UUID
  public String getUUID()
  {
    return uuid;
  }

  public void setUUID(String uuid)
  {
    this.uuid = uuid;
  }

  public Element asXMLElement(Document document)
  {
    return asXMLElement(document, null);
  }

  public Element asXMLElement(Document document, Element BinaryOnly_element)
  {
    // Creating XML block for BinaryOnly
    if (BinaryOnly_element == null)
    {
      BinaryOnly_element =
        document.createElementNS(NAMESPACE, "BinaryOnly");
    }

    // Ensure any base annotations add their Elements first
    super.asXMLElement(document, BinaryOnly_element);

    if (metadataFile != null)
    {
      // Attribute property MetadataFile
      BinaryOnly_element.setAttribute("MetadataFile", metadataFile);
    }
    if (uuid != null)
    {
      // Attribute property UUID
      BinaryOnly_element.setAttribute("UUID", uuid);
    }

    return BinaryOnly_element;
  }
}
